import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.StringReader;
import java.io.Writer;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.sax.SAXSource;
import javax.xml.transform.stream.StreamResult;
import org.xml.sax.InputSource;

// tranform.htmlˤ2ĤTextAreaΤ줾XML,XSLTϤ򸵤
// Transformer饹Ѵη̤ȤƤHTML
public class FormTransformerServlet extends HttpServlet  {

  // Υ饹tranform.htmlǡƤ鵯ư
  // tranform.html"POST"᥽åɤˤXML,XSLTƤ
  public void doPost( HttpServletRequest req, HttpServletResponse res )
                                      throws IOException, ServletException  {

    // tranform.htmlƤǡʸɤϼưꤹ
    req.setCharacterEncoding( "JISAutoDetect" );
    // 餫ǡHTMLʸɤUTF-8Ȥ
    res.setContentType( "text/html;charset=UTF-8" );

    // tranform.htmlTextAreaϤ줿XML,XSLT
    String  xml = req.getParameter( "xml" );
    String  xsl = req.getParameter( "xsl" );

    // XML,XSLTΤɤ餬ʤServletException򥹥()
    if ( xml == null  ||  xsl == null )
            throw new ServletException( "XSL,XMLʸꤷƤ" );

    // Web֥饦ؤHTML
    Writer out = new PrintWriter( new OutputStreamWriter(
                                  res.getOutputStream(), "UTF-8" ) );

    try {

      // TransformerѤXML, XSLT줾ɤ߹߸ꤹ
      // ǤSAXSourceѤSAXѡˤϤԤ褦ꤹ
      SAXSource       xslIn
           = new SAXSource( new InputSource( new StringReader( xsl ) ) );
      SAXSource       xmlIn
           = new SAXSource( new InputSource( new StringReader( xml ) ) );

      // TransformerѤHTMLνꤹ
      // ǤTransformerˤѴ̤ľWeb֥饦
      StreamResult  htmlOut = new StreamResult( out );

      // TransformerFactoryΥ󥹥󥹤
      TransformerFactory tf = TransformerFactory.newInstance();
      // XSLTɤ߹TransformerΥ󥹥󥹤
      Transformer         t = tf.newTransformer( xslIn );

      // Ѵ̤νˡHTMLȤ
      t.setOutputProperty( "method", "html" );
      // Ѵ̤ʸɤUTF-8Ȥ
      t.setOutputProperty( "encoding", "UTF-8" );

      // XMLɤ߹HTMLѴ
      t.transform( xmlIn, htmlOut );

      out.flush();

    } catch( TransformerConfigurationException ex ) {

      throw new ServletException( ex.toString() );

    } catch( TransformerException ex ) {

      throw new ServletException( ex.toString() );

    } finally {

      out.close();

    }

  }

}
