import java.io.InputStreamReader;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Reader;
import java.io.Writer;
import java.util.Properties;
import java.util.StringTokenizer;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.stream.StreamResult;

// URLκǸˤĤ줿'?(Ѵ̾)'ץѥƥեˤ
// XML,XSLTե̾Transformer饹ȤäHTMLѴ
public class TransformerServlet extends HttpServlet  {

  String          docDir = null,  // ץѥƥե뤬ǥ쥯ȥ
                propFile = null,  // ץѥƥե̾
           pathSeparator = null;  // XML, XSLTγƥեڤ뵭

  // ServletContextϥץѥƥեɤ߹ߤ˻Ѥ
  ServletContext context = null;

  // Ѵ̾ΤȼºݤXML,XSLTե̾ΤȤδϢդԤ
  // Properties֥
  Properties   transProp = null;


  public void init()  {

    // ѿν
    // web.xml<init-param>ˤXSLTե뤬Ǽ줿
    // ǥ쥯ȥ򤢤餫ꤷƤ
           docDir = getServletConfig().getInitParameter( "docdir" );
    // ץѥƥե̾
         propFile = "transform.properties";
    // ץѥƥեǻѤXML,XSLTե̾Τζڤ
    pathSeparator = ":";

    // ѡ饹Υ᥽åɤˤServletContext֥Ȥ
          context = getServletContext();

    // Properties֥Ȥ
        transProp = new Properties();

    try {

      // ץѥƥեƤɤ߹ߡProperties֥Ȥ
      transProp.load( context.getResourceAsStream( docDir + propFile ) );

    } catch( IOException ex )  {

      System.out.println( "ץѥƥե:" + propFile
                          + "ɤ߹ޤǤ" );
      System.out.println( ex.toString() );

    }

  }
  
  // ֥åȤ˥뤿Ӥ˵ư᥽å
  public void doGet( HttpServletRequest req, HttpServletResponse res )
                                      throws IOException, ServletException  {

    // URLκǸˤĤ줿'?(Ѵ̾)'ץѥƥե
    // 򸵤ˡѴ̾Τ˴Ϣդ줿XML, XSLTե̾Τ
    String[] doc = getResourceNames( req.getQueryString() );

    if ( doc == null )
            throw new ServletException( "XSL,XMLʸꤷƤ" );

    // Web֥饦ؤHTML
    Writer out = new PrintWriter( new OutputStreamWriter(
                                  res.getOutputStream(), "UTF-8" ) );

    // 餫ǡHTMLʸɤUTF-8Ȥ
    res.setContentType( "text/html;charset=UTF-8" );

    try {

      // TransformerѤXML,XSLTɤ߹߸ȤʤReader
      Reader xml = new InputStreamReader(
                       context.getResourceAsStream(
                           docDir + doc[ 0 ] + ".xml" ), "JISAutoDetect" );
      Reader xsl = new InputStreamReader(
                       context.getResourceAsStream(
                           docDir + doc[ 1 ] + ".xsl" ), "JISAutoDetect" );

      // TransformerѤXML,XSLTɤ߹߸ꤹ
      // XML, XSLTȤ˥ե뤫뤿ᡢStreamSource
      StreamSource    xmlIn = new StreamSource( xml );
      StreamSource    xslIn = new StreamSource( xsl );

      // ǤTransformerˤѴ̤ľWeb֥饦
      StreamResult  htmlOut = new StreamResult( out );

      // TransformerFactoryΥ󥹥󥹤
      TransformerFactory tf = TransformerFactory.newInstance();
      // XSLTɤ߹TransformerΥ󥹥󥹤
      Transformer         t = tf.newTransformer( xslIn );

      // Ѵ̤νˡHTMLȤ
      t.setOutputProperty( "method", "html" );
      // Ѵ̤ʸɤUTF-8Ȥ
      t.setOutputProperty( "encoding", "UTF-8" );
      // XMLɤ߹HTMLѴ
      t.transform( xmlIn, htmlOut );

      out.flush();

    } catch( TransformerConfigurationException ex ) {

      throw new ServletException( ex.toString() );

    } catch( TransformerException ex ) {

      throw new ServletException( ex.toString() );

    } finally {

      out.close();

    }

  }

  // ץѥƥե(Ѵ̾=XMLե̾:XSLTե̾)
  // 顢Ѵ̾Τ˴Ϣդ줿ƥե̾ΤФͤȤ
  private String[] getResourceNames( String queryString )  {

    // Properties֥ȤѴ̾Τ򸵤˥ץѥƥ
    // (Ǥͤ'XMLե̾:XSLTե̾')
    String prop = transProp.getProperty( queryString );

    // ץѥƥͤ顢XMLե̾ΤXSLTե̾ΤФ
    // token[0]=XMLե̾,token[1]=XSLTե̾
    StringTokenizer st = new StringTokenizer( prop, pathSeparator );
    int            len = st.countTokens();
    String[]     token = new String[ len ];

    for( int i = 0; i < len; i++ )  token[ i ] = st.nextToken();

    // ץѥƥͤФ줿XMLե̾ΤXSLTե̾Τ֤
    return token;

  }

}
