import java.io.InputStreamReader;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Reader;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.stream.StreamResult;

// JSPˤꡢǡ١򸡺Ƥ줿XML򸵤
// Transformer饹ȤäHTMLѴ
public class JSP2XMLTransformerServlet extends HttpServlet  {

  String          docDir = null,  // ѤXSLTե뤬ǥ쥯ȥ
                  xslDoc = null;  // ѤXSLTե̾
  ServletContext context = null;  // ServletContextXSLTɤ߹ߤ˻Ѥ

  // ֥åȤϤƼ¹Ԥݤ˵ư᥽å
  public void init()  {

    // ѿν
    // web.xml<init-param>ˤXSLTե뤬Ǽ줿
    // ǥ쥯ȥ򤢤餫ꤷƤ
     docDir = getServletConfig().getInitParameter( "docdir" );
    // ǤXSLTե򤢤餫ꤷƤ
     xslDoc = "rdbFull.xsl";
    // ѡ饹Υ᥽åɤˤServletContext֥Ȥ
    context = getServletContext();

  }

  // ֥åȤ˥뤿Ӥ˵ư᥽å
  public void doGet( HttpServletRequest req, HttpServletResponse res )
                                        throws IOException, ServletException  {

    // Web֥饦ؤHTML
    Writer out = new PrintWriter( new OutputStreamWriter(
                                  res.getOutputStream(), "UTF-8" ) );

    // ֥饦Ƥǡʸɤϼưꤹ
    req.setCharacterEncoding( "JISAutoDetect" );
    // 餫ǡHTMLʸɤUTF-8Ȥ
    res.setContentType( "text/html;charset=UTF-8" );

    try {

      // Υ֥åȤ˥URLθ'?(XMLJSP̾)'
      // ȻꤷơXMLJSPꤷƤ
      String retrieve = req.getQueryString();
      if ( retrieve == null )
                         throw new ServletException( "JSPꤷƤ" );

      // TransformerѤXMLɤ߹߸ȤʤReader
      // (ǤJSPURLϸͤǤѿѤƤɤǤ礦)
      URL url = new URL( "http://localhost:8080/transform/" + retrieve );
      Reader xml = new InputStreamReader( url.openStream(), "UTF-8" );

      // TransformerѤXSLTɤ߹߸ȤʤReader
      Reader xsl = new InputStreamReader( 
                       context.getResourceAsStream(
                           docDir + xslDoc ), "JISAutoDetect" );

      // TransformerѤXML,XSLTɤ߹߸ꤹ
      // XMLJSPˤ̤Ѥ뤿ᡢStreamSource
      // XSLTϥե뤫뤿ᡢStreamSource
      StreamSource    xmlIn = new StreamSource( xml );
      StreamSource    xslIn = new StreamSource( xsl );

      // ǤTransformerˤѴ̤ľWeb֥饦
      StreamResult  htmlOut = new StreamResult( out );

      // TransformerFactoryΥ󥹥󥹤
      TransformerFactory tf = TransformerFactory.newInstance();
      // XSLTɤ߹TransformerΥ󥹥󥹤
      Transformer         t = tf.newTransformer( xslIn );

      // Ѵ̤νˡHTMLȤ
      t.setOutputProperty( "method", "html" );
      // Ѵ̤ʸɤUTF-8Ȥ
      t.setOutputProperty( "encoding", "UTF-8" );

      // XMLɤ߹HTMLѴ
      t.transform( xmlIn, htmlOut );

      out.flush();

    } catch( MalformedURLException ex )  {

      throw new ServletException( ex.toString() );

    } catch( TransformerConfigurationException ex )  {

      throw new ServletException( ex.toString() );

    } catch( TransformerException ex )  {

      throw new ServletException( ex.toString() );

    } finally {

      out.close();

    }

  }

}
