<?xml version="1.0" encoding="EUC-JP"?>
<xsl:transform version="1.0"
               xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:output method="html" encoding="UTF-8" indent="yes" />

  <xsl:template match="/">
    <html>
      <head>
        <style type="text/css">&lt;!--
          .center  { text-align: center; }
        --&gt;</style>
        <title>ʸΰ(ȴ)</title>
      </head>
      <body>
        <div class="center">
          <h2>ʸΰ(ȴ)</h2>
          <table border="1">
            <tr>
              <th>ȥ</th><th></th><th>Ǽ</th>
            </tr>
            <xsl:apply-templates />
          </table>
        </div>
      </body>
    </html>
  </xsl:template>

  <xsl:template match="book">
    <tr>
      <td>
        <xsl:element name="a">
          <xsl:attribute name="href">
            <xsl:value-of select="url" />
          </xsl:attribute>
          <xsl:value-of select="title" />
        </xsl:element>
      </td>
      <td><xsl:value-of select="author" /></td>
      <td><xsl:value-of select="publisher" /></td>
    </tr>
  </xsl:template>

</xsl:transform>
