<?xml version="1.0" encoding="EUC_JP"?>
<xsl:transform version="1.0"
               xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:output method="html" encoding="EUC_JP" indent="yes" />

  <xsl:template match="/">
    <html>
      <head>
        <style type="text/css">&lt;!--
          .center  { text-align: center; }
          .right   { text-align: right;  }
        --&gt;</style>
        <title>ʸΰ</title>
      </head>
      <body>
        <div class="center">
          <h2>ʸΰ</h2>
          <table border="1">
            <tr>
              <th>ISBN</th><th>ȥ</th><th></th><th>Ǽ</th><th></th>
            </tr>
            <xsl:apply-templates />
          </table>
        </div>
        <div class="right">(ʤϳ)</div>
      </body>
    </html>
  </xsl:template>

  <xsl:template match="book">
    <tr>
      <td><xsl:value-of select="isbn" /></td>
      <td>
        <xsl:element name="a">
          <xsl:attribute name="href">
            <xsl:value-of select="url" />
          </xsl:attribute>
          <xsl:value-of select="title" />
        </xsl:element>
      </td>
      <td><xsl:value-of select="author" /></td>
      <td><xsl:value-of select="publisher" /></td>
      <td><xsl:value-of select="price" /></td>
    </tr>
  </xsl:template>

</xsl:transform>
