<%@ page language="java" contentType="text/html;charset=EUC_JP"
                         pageEncoding="EUC_JP" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/xtags-1.0" prefix="xtags" %>

<xtags:parse uri="/books.xml" />

<xtags:stylesheet>
  <xtags:template match="/">
    <html>
      <head>
        <style type="text/css"><!--
          .center  { text-align: center; }
          .right   { text-align: right;  }
        --></style>
        <title>ʸΰ</title>
      </head>
      <body>
        <div class="center">
          <h2>ʸΰ</h2>
          <table border="1">
            <tr>
              <th>ISBN</th><th>ȥ</th><th></th><th>Ǽ</th><th></th>
            </tr>
            <xtags:applyTemplates />
          </table>
        </div>
        <div class="right">(ʤϳ)</div>
      </body>
    </html>
  </xtags:template>

  <xtags:template match="book">
    <tr>
      <td><xtags:valueOf select="isbn" /></td>
      <td>
        <xtags:element name="a">
          <xtags:attribute name="href">
            <xtags:valueOf select="url" />
          </xtags:attribute>
          <xtags:valueOf select="title" />
        </xtags:element>
      </td>
      <td><xtags:valueOf select="author" /></td>
      <td><xtags:valueOf select="publisher" /></td>
      <td><xtags:valueOf select="price" /></td>
    </tr>
  </xtags:template>
</xtags:stylesheet>